#include <initguid.h>
#include "Water_DLL.h"
#include <limits>

//Copyright (C) cocosimulator.org 2014
//generated by AmsterCHEM's COM CAPE-OPEN Wizard

#include "WaterPackage.h"
/*INCLUDE_INSERT_LOCATION*/

// Globals
LONG ModuleLockCount=0;
HINSTANCE myInstanceHandle;
const double CapeDoubleMissingValue=numeric_limits<double>::quiet_NaN(); 


// class-factory: this is a template class suitable only for creating the
//  template argument's COM class

template <class COMOBJECT>
class CClassFactory : public COMObject, public IClassFactory {
public:

	IMPLEMENT_IUNKNOWN

	virtual void *InternalQueryInterface(REFIID riid) {
		void *res;
		if (riid==IID_IClassFactory) {
			res=(IClassFactory*)this;
		} else {
			res=NULL;
		}
		return res;
	}

	// IClassFactory

	STDMETHOD(CreateInstance)(LPUNKNOWN punkOuter, REFIID iid, void **ppv) {
		LPUNKNOWN   punk;
		HRESULT     hr;
		*ppv = NULL;
		if (punkOuter != NULL) {
			return CLASS_E_NOAGGREGATION;    //we do not support aggregated classes
		}
		punk = (COMObject*)new COMOBJECT;
		if (punk == NULL) {
			return E_OUTOFMEMORY;
		}
		hr = punk->QueryInterface(iid, ppv);
		punk->Release();
		return hr;
	}

	STDMETHOD(LockServer)(BOOL incr) {
		if (incr) {
			InterlockedIncrement(&ModuleLockCount);
		} else {
			InterlockedDecrement(&ModuleLockCount);
		}
		return NOERROR;
	}

};

//Main DLL functions

WINAPICALL(HRESULT) DllCanUnloadNow(void) {
	//we can unload if no COM objects are active anymore
	InterlockedIncrement(&ModuleLockCount);
	return (InterlockedDecrement(&ModuleLockCount)==0)?S_OK:S_FALSE;
}

// Returns a class factory to create an object of the requested type
WINAPICALL(HRESULT) DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv) {
	if (!ppv) {
		return E_POINTER;
	}
	LPUNKNOWN punk;
	*ppv = NULL;
	if (rclsid==CLSID_WaterPackage) {
		punk=(COMObject*)new CClassFactory<WaterPackage>;
	/*CLASS_INSERT_LOCATION*/
	} else {
		//class not served from our server:
		return CLASS_E_CLASSNOTAVAILABLE;
	}
	if (!punk) {
		return E_OUTOFMEMORY; //new failed
	}
	HRESULT hr=punk->QueryInterface(riid,ppv);
	punk->Release();
	return hr;
}

//registry entry definitions:

typedef struct {
	const char *subKey;
	const char *value;
	const char *content;
} RegEntry;

#define MODULENAME (const char *)1
#define COMPONENTVERSION (const char *)2

const RegEntry regEntries[]= {
	//COM server registry entries
	{"Software\\Classes\\AppID\\{8D3663F4-EE76-4201-A38E-4849ABB54300}",NULL,NULL},
	{"Software\\Classes\\AppID\\{8D3663F4-EE76-4201-A38E-4849ABB54300}",NULL,"Water"},
	{"Software\\Classes\\AppID\\Water",NULL,NULL},
	{"Software\\Classes\\AppID\\Water","AppID","{8D3663F4-EE76-4201-A38E-4849ABB54300}"},
	//WaterPackage registry entries: 
	{"Software\\Classes\\Steamer.SteamerPackage",NULL,NULL},
	{"Software\\Classes\\Steamer.SteamerPackage",NULL,"Water"},
	{"Software\\Classes\\Steamer.SteamerPackage\\CLSID",NULL,NULL},
	{"Software\\Classes\\Steamer.SteamerPackage\\CLSID",NULL,"{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}"},
	{"Software\\Classes\\Steamer.SteamerPackage\\CurVer",NULL,NULL},
	{"Software\\Classes\\Steamer.SteamerPackage\\CurVer",NULL,"Steamer.SteamerPackage.1"},
	{"Software\\Classes\\Steamer.SteamerPackage.1",NULL,NULL},
	{"Software\\Classes\\Steamer.SteamerPackage.1",NULL,"Water"},
	{"Software\\Classes\\Steamer.SteamerPackage.1\\CLSID",NULL,NULL},
	{"Software\\Classes\\Steamer.SteamerPackage.1\\CLSID",NULL,"{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}",NULL,"Water"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\ProgID",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\ProgID",NULL,"Steamer.SteamerPackage.1"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\VersionIndependentProgID",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\VersionIndependentProgID",NULL,"Steamer.SteamerPackage"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\InprocServer32",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\InprocServer32",NULL,MODULENAME},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\InprocServer32","ThreadingModel","Apartment"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\InprocServer32","AppID","Water"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\Implemented Categories",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\Implemented Categories\\{678c09a1-7d66-11d2-a67d-00105a42887f}",NULL,NULL}, //CAPE-OPEN Component
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\Implemented Categories\\{cf51e384-0110-4ed8-acb7-b50cfde6908e}",NULL,NULL}, //CAPE-OPEN Physical Property Package 1.1
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription",NULL,NULL},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","Name","Water"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","Description","IAPWS-97 based Property Package for calculation of water and steam"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","CapeVersion","1.1"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","ComponentVersion",COMPONENTVERSION},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","VendorURL","http://www.cocosimulator.org/"},
	{"Software\\Classes\\CLSID\\{3ABCC2E6-3E2A-43C6-B607-A3BE7F0CA482}\\CapeDescription","About","CAPE-OPEN 1.0 Water Property Package - 2014 cocosimulator.org"},
	/*REGISTRY_INSERT_LOCATION*/
};

string GetRegStringEntry(const char *src) {
	string res;
	//replace special string values
	if (src==MODULENAME) {
		//full path to executing module
		char *buf;
		buf=new char[1024];
		GetModuleFileNameA(myInstanceHandle,buf,1024);
		res=buf;
		delete []buf;
	} else if (src==COMPONENTVERSION) {
		//component version; read my own version resource
		res="<unknown>"; //in case we fail this routine
		char *buf;
		buf=new char[1024];
		GetModuleFileNameA(myInstanceHandle,buf,1024);
		if (GetFileVersionInfoA(buf,NULL,1024,(LPVOID*)buf)) {
			VS_FIXEDFILEINFO *version;
			UINT puLen;
			if (VerQueryValueA(buf,"\\",(LPVOID*)&version,&puLen)) {
				#ifdef _MSC_VER
				#pragma warning (disable:4996)
				#endif
				char smallBuf[128];
				res.clear();
				sprintf(smallBuf,"%d",HIWORD(version->dwFileVersionMS));
				res+=smallBuf;
				res+='.';
				sprintf(smallBuf,"%d",LOWORD(version->dwFileVersionMS));
				res+=smallBuf;
				res+='.';
				sprintf(smallBuf,"%d",HIWORD(version->dwFileVersionLS));
				res+=smallBuf;
				res+='.';
				sprintf(smallBuf,"%d",LOWORD(version->dwFileVersionLS));
				res+=smallBuf;
			}
		}
		delete []buf;
	} else {
		//string literal
		res=src;
	}
	return res;
};

// Check per user or all users registration, specific to COCO installation:
HKEY GetRootKey() {
	TCHAR szTemp[20];
	HKEY res=HKEY_LOCAL_MACHINE;
	HKEY key;
	if (RegOpenKeyEx(HKEY_CURRENT_USER,L"Software\\COCO",0,KEY_READ,&key)==ERROR_SUCCESS) {
		DWORD type,size;
		size=20;
		if (RegQueryValueEx(key,L"CurrentUser",0,&type,(LPBYTE)szTemp,&size)==ERROR_SUCCESS)
			if (lstrcmpi(szTemp,L"1")==0) {
				res=HKEY_CURRENT_USER;
			}
		RegCloseKey(key);
	}
	return res;
}

// DllRegisterServer - Adds entries to the system registry
WINAPICALL(HRESULT) DllRegisterServer() {
	// registers object, typelib and all interfaces in typelib
	const int nEntries=sizeof(regEntries)/sizeof(RegEntry);
	int i;
	HKEY key;
	HRESULT res=E_UNEXPECTED;
	HKEY keyRoot=GetRootKey();
	for (i=0; i<nEntries; i++) {
		const RegEntry *entry=regEntries+i;
		if (!entry->content) {
			//create key
			if (ERROR_SUCCESS!=RegCreateKeyExA(keyRoot,entry->subKey,NULL,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&key,NULL)) {
				break;
			}
			RegCloseKey(key);
		} else {
			//set string value
			if (ERROR_SUCCESS!=RegCreateKeyExA(keyRoot,entry->subKey,NULL,NULL,REG_OPTION_NON_VOLATILE,KEY_WRITE,NULL,&key,NULL)) {
				break;
			}
			{
				string val=GetRegStringEntry(entry->content);
				if (ERROR_SUCCESS!=RegSetValueExA(key,entry->value,NULL,REG_SZ,(const BYTE*)val.c_str(),(DWORD)(val.size()+1))) {
					//fail, bail out
					RegCloseKey(key);
					break;
				}
			}
			RegCloseKey(key);
		}
	}
	if (i==nEntries) {
		res=NOERROR;
	}
	return res;
}

// DllUnregisterServer - Removes entries from the system registry

void RemoveKeyRecursive(HKEY rootKey,const char *subKey) {
	//recursively remove sub keys
	HKEY key;
	if (ERROR_SUCCESS!=RegOpenKeyExA(rootKey,subKey,0,KEY_WRITE|KEY_READ,&key)) {
		return;    //failed to open key. Presume it is not there, or we do not have write access
	}
	DWORD index=0;
	char *subKeyName;
	FILETIME ft;
	unsigned int i;
	vector<string> subKeyNames;
	subKeyName=new char[1024];
	if (!subKeyName) {
		//no memory, cannot proceed
		RegCloseKey(key);
		return;
	}
	for (;;) {
		unsigned long len;
		len=1024;
		LONG res=RegEnumKeyExA(key,index,subKeyName,&len,NULL,NULL,0,&ft);
		if (res==ERROR_NO_MORE_ITEMS) {
			break;
		}
		if (res!=ERROR_SUCCESS) {
			break;    //something goes wrong, best not to keep trying
		}
		subKeyNames.push_back(subKeyName);
		index++;
	}
	delete []subKeyName;
	//remove all sub keys
	for (i=0; i<subKeyNames.size(); i++) {
		RegDeleteKeyA(key,subKeyNames[i].c_str());
	}
	//done with key
	RegCloseKey(key);
	//remove the key itself
	RegDeleteKeyA(rootKey,subKey);
}

WINAPICALL(HRESULT) DllUnregisterServer() {
	const int nEntries=sizeof(regEntries)/sizeof(RegEntry);
	int i;
	HKEY keyRoot=GetRootKey();
	for (i=nEntries-1; i>=0; i--) {
		const RegEntry *entry=regEntries+i;
		if (!entry->content) {
			//remove key and all its sub-keys
			RemoveKeyRecursive(keyRoot,entry->subKey);
		}
	}
	return NOERROR;
}

WINAPICALL(BOOL) DllMain(HINSTANCE instance, DWORD dwReason, LPVOID ) {
	switch (dwReason) {
	case DLL_PROCESS_ATTACH:
		myInstanceHandle=instance;
		//additional initialization tasks
		break;
	case DLL_PROCESS_DETACH:
		//additional cleanup tasks
		break;
	}
	return TRUE;
}

